//
//  Lesson 7
//
//  Created by Jiva DeVoe on 12/5/12.
//  Copyright (c) 2012 Random Ideas. All rights reserved.
//

// **The Old Way**
// Here, it's difficult to tell whether `someOtherVariable` is local or a member variable.

@implementation Foo
-(void)doSomething
{
    NSString *someLocalVariable = ...;
    // do some things...
    someLocalVariable = ...;
    someOtherVariable = ...;
    [someOtherVariable doSomething:someLocalVariable];
}
@end


// **The Modern Way**

@implementation Foo
-(void)doSomething
{
    NSString *someLocalVariable = ...;
    // do some things...
    someLocalVariable = ...;
    self.someOtherVariable = ...;
    [self.someOtherVariable doSomething:someLocalVariable];
}
@end

@implementation Foo
-(void)doSomething
{
    NSString *someLocalVariable = ...;
    // do some things...
    someLocalVariable = ...;
    _someOtherVariable = ...;
    [_someOtherVariable doSomething:someLocalVariable];
}
@end

















