//
//  PrimeFinder.m
//  Lesson4a
//
//  Created by Jiva DeVoe on 12/3/12.
//  Copyright (c) 2012 Random Ideas. All rights reserved.
//

#import "PrimeFinder.h"


@interface PrimeFinder ()
@property NSInteger maxNumber;
@property NSInteger completed;
@property BOOL finished;
@end

@implementation PrimeFinder
@dynamic elapsedTime;

-(id)initWithMaxNumber:(NSInteger)inMaxNumber
{
    if((self = [super init]))
    {
        _maxNumber = inMaxNumber;
        _primes = [@[] mutableCopy];
    }
    return self;
}

-(BOOL)isPrime:(NSInteger)number
{
    for(NSInteger n = 2; n < number; ++n)
        if((number % n) == 0)
            return NO;
    return YES;
}

-(void)start
{
    dispatch_queue_t dispatchQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);

    [self setStartedDate:[NSDate date]];
    for(NSInteger n = 2; n <= self.maxNumber; ++n)
    {
        dispatch_async(dispatchQueue, ^
        {
            if([self isPrime:n])
            {
                @synchronized(self)
                {
                    [self.primes addObject:[NSNumber numberWithInteger:n]];
                }
            }
            @synchronized(self)
            {
                self.completed++;
                if(self.completed >= self.maxNumber-1)
                {
                    [self setEndedDate:[NSDate date]];
                    self.finished = YES;
                }
            }
        });
    }
}

-(NSTimeInterval)elapsedTime
{
    return [self.endedDate timeIntervalSinceDate:self.startedDate];
}

@end