//
//  PrimeFinder.m
//  Lesson4a
//
//  Created by Jiva DeVoe on 12/3/12.
//  Copyright (c) 2012 Random Ideas. All rights reserved.
//

#import "PrimeFinder.h"


@interface PrimeFinder ()
@property NSInteger maxNumber;
@property NSInteger completed;
@property BOOL finished;
@end

@implementation PrimeFinder
@dynamic elapsedTime;

-(id)initWithMaxNumber:(NSInteger)inMaxNumber
{
    if((self = [super init]))
    {
        _maxNumber = inMaxNumber;
        _primes = [@[] mutableCopy];
    }
    return self;
}

-(BOOL)isPrime:(NSInteger)number
{
    for(NSInteger n = 2; n < number; ++n)
        if((number % n) == 0)
            return NO;
    return YES;
}

-(void)start
{
    dispatch_queue_t dispatchQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    dispatch_group_t group = dispatch_group_create();
    
    [self setStartedDate:[NSDate date]];
    for(NSInteger n = 2; n <= self.maxNumber; ++n)
    {
        dispatch_block_t isPrime = ^
        {
            if([self isPrime:n])
            {
                @synchronized(self)
                {
                    [self.primes addObject:[NSNumber numberWithInteger:n]];
                }
            }
        };
        dispatch_group_async(group, dispatchQueue, isPrime);
    }
 
    dispatch_group_wait(group, DISPATCH_TIME_FOREVER); // danger! this will block your current thread!
    [self setEndedDate:[NSDate date]];
    self.finished = YES;
}

-(NSTimeInterval)elapsedTime
{
    return [self.endedDate timeIntervalSinceDate:self.startedDate];
}

@end