
//
//  PrimeFinder.m
//  Lesson4a
//
//  Created by Jiva DeVoe on 12/3/12.
//  Copyright (c) 2012 Random Ideas. All rights reserved.
//

#import "PrimeFinder.h"


@interface PrimeFinder ()
@property NSInteger maxNumber;
@property NSInteger completed;
@property (strong) NSOperationQueue *primeQueue;
@end

@implementation PrimeFinder
@dynamic elapsedTime;
@dynamic finished;

-(id)initWithMaxNumber:(NSInteger)inMaxNumber
{
    if((self = [super init]))
    {
        _maxNumber = inMaxNumber;
        _primes = [@[] mutableCopy];
        _primeQueue = [NSOperationQueue new];
    }
    return self;
}

-(BOOL)isPrime:(NSInteger)number
{
    for(NSInteger n = 2; n < number; ++n)
        if((number % n) == 0)
            return NO;
    return YES;
}

-(void)start
{

    [self setStartedDate:[NSDate date]];
    for(NSInteger n = 2; n <= self.maxNumber; ++n)
    {
        NSBlockOperation *operation = [NSBlockOperation blockOperationWithBlock:^
        {
            if([self isPrime:n])
            {
                @synchronized(self)
                {
                    [self.primes addObject:[NSNumber numberWithInteger:n]];
                }
            }
        }];
        
        operation.completionBlock = ^
        {
            @synchronized(self)
            {
                [self setEndedDate:[NSDate date]];
            }
        };
        
        [self.primeQueue addOperation:operation];
    }
 }

-(NSTimeInterval)elapsedTime
{
    return [self.endedDate timeIntervalSinceDate:self.startedDate];
}

-(BOOL)finished
{
    return ([self.primeQueue operationCount] == 0);
}

@end