//
//  main.m
//  Lesson4b
//
//  Created by Jiva DeVoe on 12/3/12.
//  Copyright (c) 2012 Random Ideas. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "NSData+CryptoHashing.h"

int main(int argc, const char * argv[])
{
    @autoreleasepool
    {

        dispatch_queue_t dispatchQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
        
        __block NSString *synchronize = @"Synchronize";
        
        long iterations = 10000000;
        __block long completed = 0;
        
        NSLog(@"Calculating sha256 hash %ld times at: %@", iterations, [NSDate date]);
        for(long n = 0; n <= iterations; ++n)
        {
            NSBlockOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                <#code#>
            }]
            
            dispatch_async(dispatchQueue, ^
            {
                NSString *corpus = @"Now is the time for all good men to come to the aide of their country.";
                NSData *data = [corpus dataUsingEncoding:NSUTF8StringEncoding];
                [data sha256Hash];
                
                @synchronized(synchronize)
                {
                    completed += 1;
                }
            });
        }
        
        BOOL finished = NO;
        do
        {
            @synchronized(synchronize)
            {
                finished = (completed >= iterations);
                NSLog(@"%ld", completed);
            }
            sleep(1);
        }while(!finished);
        
        NSLog(@"Finished: %@", [NSDate date]);
    }
    return 0;
}

